/*===========================================================================*\

   $Id$

   Base class for actions to be performed when a key is pressed or released.

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef KEYCOMMAND_H
#define KEYCOMMAND_H

#include <spug/RCBase.h>
#include <spug/RCPtr.h>

namespace wurld {
   typedef int KeyCode;
}

/**
 * The abstract interface for all key commands.
 */
class KeyCommand : public spug::RCBase {
   public:
      virtual void handleKeyPress(wurld::KeyCode key) = 0;
      virtual void handleKeyRelease(wurld::KeyCode key) = 0;
};

SPUG_RCPTR(KeyCommand);

#endif
