/*===========================================================================*\

   $Id$

   Handler for keyboard input - maintains key bindings and dispatches
   keystrokes.

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef KEYHANDLER_H
#define KEYHANDLER_H

#include "KeyCommand.h"

#include <map>

SPUG_RCPTR(KeyCommand);

class KeyHandler {
   private:
      typedef std::map<wurld::KeyCode, KeyCommandPtr> KeyMap;
      KeyMap keyMap;

   public:

      /**
       * Bind a key to a command to be invoked when the key is pressed or
       * released.
       */
      void bind(wurld::KeyCode key, const KeyCommandPtr &command);

      /**
       * Called by the display driver to handle key press and release events.
       */
      /** @{ */
      void handleKeyPress(wurld::KeyCode key) const;
      void handleKeyRelease(wurld::KeyCode key) const;
      /** @} */
};

#endif
