/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#include "PlanarMesh.h"

#include "Material.h"

PlanarMesh::PlanarMesh(const Vector &normal, const MaterialPtr &material) :
   normal(normal),
   material(material) {
}

void PlanarMesh::removeQuad(const Quad &quad) {
   for (QuadVector::iterator iter = quads.begin();
        iter != quads.end();
        ++iter
        ) {
      if (quad == *iter) {
         quads.erase(iter);
         break;
      }
   }
}

void PlanarMesh::render(Scene &scene) {
   QuadVector::iterator iter;
   glBegin(GL_QUADS);
   glNormal<Float>(normal.x, normal.y, normal.z);
   for (iter = quads.begin(); iter != quads.end(); ++iter) {
      for (int i = 0; i < 4; ++i) {
         Vertex &v = (*iter)[i];
         material->setCoord(v);
         glVertex(v.Vector::x, v.Vector::y, v.Vector::z);
      }
   }

   glEnd();
}
