/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef PYTHONKEYCOMMAND_H
#define PYTHONKEYCOMMAND_H

#include <Python.h>
#include "KeyCommand.h"

/**
 * Key command implementation that calls python code.
 */
class PythonKeyCommand : public KeyCommand {
   private:
      PyObject *onKeyPress, *onKeyRelease;

   public:
      /**
       * @param onKeyPress callable object for handing key presses.  May be
       *                   NULL.
       * @param onKeyRelease callable object for handling key release.  May be
       *                     NULL.
       */
      PythonKeyCommand(PyObject *onKeyPress, PyObject *onKeyRelease);
      ~PythonKeyCommand();

      virtual void handleKeyPress(wurld::KeyCode keyCode);
      virtual void handleKeyRelease(wurld::KeyCode keyCode);
};

SPUG_RCPTR(PythonKeyCommand);

#endif
