/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#include "TextBuffer.h"

TextBuffer::TextBuffer(const char *data) : data(data) {}

TextBuffer::Cursor TextBuffer::getPos(unsigned row, unsigned column) const {
   const char *pos = data.c_str();

   // find the row
   while (*pos && row) {
      for (; *pos && *pos != '\n'; ++pos) ;
      ++pos;
      --row;
   }

   // find the column
   while (*pos && *pos != '\n' && column) {
      ++pos;
      --column;
   }

   if (*pos)
      return createCursor(pos, pos + strlen(pos));
   else
      return createCursor(0, pos);
}
