/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef TEXTPANE_H
#define TEXTPANE_H

#include "RenderableObject.h"
#include "TextModel.h"

/**
 * A 2D control that displays text.
 */
class TextPane : public RenderableObject {
   private:
      TextModelPtr model;

      // start row and column position in the text
      unsigned row, column;

      Float top, left, width, height;


   public:
      TextPane(const TextModelPtr &model, Float left, Float top, Float width, 
               Float height);

      void render(Scene &scene);
};

#endif
