#==============================================================================
#
#  $Id$
#
"""
   Illustrates key bindings - turns lighting on and off.
"""
#
#  Copyright (C) 2007 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================

import wurld

lightingEnabled = True
def toggleLights(keyCode):
   global lightingEnabled
   lightingEnabled = not lightingEnabled
   wurld.getGraphics().enableLighting(lightingEnabled)

# bind toggleLights to when the "l" key gets pressed, nothing to when it's
# released
keyCommand = wurld.createKeyCommand(toggleLights, None)
wurld.getDisplayDriver().getKeyHandler().bind(ord('l'), keyCommand)
