#==============================================================================
#
#  $Id$
#
"""
   A missile.
"""
#
#  Copyright (C) 2007 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================


import wurld
from turtle import *
from util import *

# create a material to use
material = wurld.createTextureMaterial(wurld.createTexture('PlasmaVomit.png'),
				       10,
				       10
				       )

class Square:

   def __init__(self, size):
      self.size = size

   def __call__(self, turtle):
      turtle.pitch(-90)
      turtle.forward(self.size / 2, False)
      turtle.yaw(90)
      turtle.forward(self.size / 2)
      for i in range(3):
         turtle.yaw(90)
         turtle.forward(self.size)

square = Square(0.5)
tool = CrossSectionTool(material, square)
turtle = Turtle(tool)

turtle.stamp()
square.size = 0
turtle.forward(1.5)
turtle.stamp()

missile = Sprite(model = tool.model)

def fire(keyCode):
   camera = wurld.getGameEngine().getCameraPtr()
   missile.origin = camera.getOrigin()
   forward = wurld.createVector(0, 0, -100)
   velocity = wurld.createVector(0, 0, 0)
   rot = camera.getRotation()
   rot.rotate(forward, velocity)
   missile.velocity = velocity

   # rotate the model to the inverse of the camera rotation
   modelRot = wurld.createYawRotMatrix(0)
   modelRot.makeInverse(rot)
   missile.rotation = modelRot

wurld.getDisplayDriver().getKeyHandler().bind(ord('a'), 
                                              wurld.createKeyCommand(fire,
                                                                     None
                                                                     )
                                              )
